From ca3d3faee9ffd8ecfd91ff6cc04c345ed8c33719 Mon Sep 17 00:00:00 2001
From: Holger Just <hjust@meine-er.de>
Date: Sat, 25 Aug 2012 13:22:48 +0200
Subject: Rails3 compatibility: replace RAILS_ROOT with Rails.root

--HG--
extra : source : bd0a75e8185d14b724031fcfe63d66c8c45358a6
---
 app/models/attachment.rb                           |    2 +-
 app/models/setting.rb                              |    2 +-
 .../chiliproject_plugin_controller_generator.rb    |    2 +-
 .../chiliproject_plugin_model_generator.rb         |    2 +-
 lib/redmine/i18n.rb                                |    2 +-
 lib/redmine/plugin.rb                              |    2 +-
 lib/redmine/scm/adapters/abstract_adapter.rb       |    6 +++---
 lib/redmine/views/my_page/block.rb                 |    2 +-
 lib/tasks/extract_fixtures.rake                    |    2 +-
 lib/tasks/initializers.rake                        |    2 +-
 test/fixtures/repositories.yml                     |    4 ++--
 test/functional/application_controller_test.rb     |    2 +-
 test/functional/attachments_controller_test.rb     |    2 +-
 .../repositories_bazaar_controller_test.rb         |    3 +--
 .../functional/repositories_cvs_controller_test.rb |    3 +--
 .../repositories_darcs_controller_test.rb          |    3 +--
 .../repositories_filesystem_controller_test.rb     |    3 +--
 .../functional/repositories_git_controller_test.rb |    3 +--
 .../repositories_mercurial_controller_test.rb      |    2 +-
 test/test_helper.rb                                |   10 +++++-----
 test/unit/changeset_test.rb                        |    4 ++--
 test/unit/helpers/repository_helper_test.rb        |    2 +-
 test/unit/lib/redmine/hook_test.rb                 |    2 +-
 .../redmine/scm/adapters/bazaar_adapter_test.rb    |    3 +--
 .../lib/redmine/scm/adapters/cvs_adapter_test.rb   |    2 +-
 .../lib/redmine/scm/adapters/darcs_adapter_test.rb |    2 +-
 .../scm/adapters/filesystem_adapter_test.rb        |    2 +-
 .../lib/redmine/scm/adapters/git_adapter_test.rb   |    2 +-
 .../redmine/scm/adapters/mercurial_adapter_test.rb |    3 +--
 test/unit/repository_bazaar_test.rb                |    4 +---
 test/unit/repository_cvs_test.rb                   |    3 +--
 test/unit/repository_darcs_test.rb                 |    3 +--
 test/unit/repository_filesystem_test.rb            |    3 +--
 test/unit/repository_git_test.rb                   |    3 +--
 test/unit/repository_mercurial_test.rb             |    4 +---
 vendor/plugins/open_id_authentication/README       |    2 +-
 vendor/plugins/rfpdf/lib/tcpdf.rb                  |    8 ++++----
 37 files changed, 48 insertions(+), 63 deletions(-)

diff --git a/app/models/attachment.rb b/app/models/attachment.rb
index e90be3b..031e905 100644
--- a/app/models/attachment.rb
+++ b/app/models/attachment.rb
@@ -56,7 +56,7 @@ class Attachment < ActiveRecord::Base
   end
 
   cattr_accessor :storage_path
-  @@storage_path = Redmine::Configuration['attachments_storage_path'] || "#{RAILS_ROOT}/files"
+  @@storage_path = Redmine::Configuration['attachments_storage_path'] || Rails.root.join("files")
 
   def validate
     if self.filesize > Setting.attachment_max_size.to_i.kilobytes
diff --git a/app/models/setting.rb b/app/models/setting.rb
index dbbe4fd..22db0e1 100644
--- a/app/models/setting.rb
+++ b/app/models/setting.rb
@@ -72,7 +72,7 @@ class Setting < ActiveRecord::Base
                   TIS-620)
 
   cattr_accessor :available_settings
-  @@available_settings = YAML::load(File.open("#{RAILS_ROOT}/config/settings.yml"))
+  @@available_settings = YAML::load(File.open(Rails.root.join("config", "settings.yml")))
   Redmine::Plugin.all.each do |plugin|
     next unless plugin.settings
     @@available_settings["plugin_#{plugin.id}"] = {'default' => plugin.settings[:default], 'serialized' => true}
diff --git a/lib/generators/chiliproject_plugin_controller/chiliproject_plugin_controller_generator.rb b/lib/generators/chiliproject_plugin_controller/chiliproject_plugin_controller_generator.rb
index 75f2e21..86fee4e 100644
--- a/lib/generators/chiliproject_plugin_controller/chiliproject_plugin_controller_generator.rb
+++ b/lib/generators/chiliproject_plugin_controller/chiliproject_plugin_controller_generator.rb
@@ -28,7 +28,7 @@ class ChiliprojectPluginControllerGenerator < ControllerGenerator
   end
 
   def destination_root
-    File.join(RAILS_ROOT, plugin_path)
+    Rails.root.join(plugin_path)
   end
 
   def manifest
diff --git a/lib/generators/chiliproject_plugin_model/chiliproject_plugin_model_generator.rb b/lib/generators/chiliproject_plugin_model/chiliproject_plugin_model_generator.rb
index d66bc04..3d36c45 100644
--- a/lib/generators/chiliproject_plugin_model/chiliproject_plugin_model_generator.rb
+++ b/lib/generators/chiliproject_plugin_model/chiliproject_plugin_model_generator.rb
@@ -28,7 +28,7 @@ class ChiliprojectPluginModelGenerator < ModelGenerator
   end
 
   def destination_root
-    File.join(RAILS_ROOT, plugin_path)
+    Rails.root.join(plugin_path)
   end
 
   def manifest
diff --git a/lib/redmine/i18n.rb b/lib/redmine/i18n.rb
index 0b050d0..61f308c 100644
--- a/lib/redmine/i18n.rb
+++ b/lib/redmine/i18n.rb
@@ -72,7 +72,7 @@ module Redmine
     end
 
     def valid_languages
-      @@valid_languages ||= Dir.glob(File.join(RAILS_ROOT, 'config', 'locales', '*.yml')).collect {|f| File.basename(f).split('.').first}.collect(&:to_sym)
+      @@valid_languages ||= Dir.glob(Rails.root.join('config', 'locales', '*.yml')).collect {|f| File.basename(f).split('.').first}.collect(&:to_sym)
     end
 
     def find_language(lang)
diff --git a/lib/redmine/plugin.rb b/lib/redmine/plugin.rb
index 8041a8a..e4ead38 100644
--- a/lib/redmine/plugin.rb
+++ b/lib/redmine/plugin.rb
@@ -85,7 +85,7 @@ module Redmine #:nodoc:
       p.name(id.to_s.humanize) if p.name.nil?
       # Adds plugin locales if any
       # YAML translation files should be found under <plugin>/config/locales/
-      ::I18n.load_path += Dir.glob(File.join(RAILS_ROOT, 'vendor', 'plugins', id.to_s, 'config', 'locales', '*.yml'))
+      ::I18n.load_path += Dir.glob(Rails.root.join('vendor', 'plugins', id.to_s, 'config', 'locales', '*.yml'))
       registered_plugins[id] = p
 
       # If there are plugins waiting for us to be loaded, we try loading those, again
diff --git a/lib/redmine/scm/adapters/abstract_adapter.rb b/lib/redmine/scm/adapters/abstract_adapter.rb
index fa3a2d1..a6b5953 100644
--- a/lib/redmine/scm/adapters/abstract_adapter.rb
+++ b/lib/redmine/scm/adapters/abstract_adapter.rb
@@ -53,9 +53,9 @@ module Redmine
 
           def shell_quote(str)
             if Redmine::Platform.mswin?
-              '"' + str.gsub(/"/, '\\"') + '"'
+              '"' + str.to_s.gsub(/"/, '\\"') + '"'
             else
-              "'" + str.gsub(/'/, "'\"'\"'") + "'"
+              "'" + str.to_s.gsub(/'/, "'\"'\"'") + "'"
             end
           end
         end
@@ -195,7 +195,7 @@ module Redmine
           logger.debug "Shelling out: #{strip_credential(cmd)}" if logger && logger.debug?
           if Rails.env == 'development'
             # Capture stderr when running in dev environment
-            cmd = "#{cmd} 2>>#{RAILS_ROOT}/log/scm.stderr.log"
+            cmd = "#{cmd} 2>>#{shell_quote Rails.root.join('log', 'scm.stderr.log')}"
           end
           begin
             if RUBY_VERSION < '1.9'
diff --git a/lib/redmine/views/my_page/block.rb b/lib/redmine/views/my_page/block.rb
index 828a947..ac44477 100644
--- a/lib/redmine/views/my_page/block.rb
+++ b/lib/redmine/views/my_page/block.rb
@@ -17,7 +17,7 @@ module Redmine
     module MyPage
       module Block
         def self.additional_blocks
-          @@additional_blocks ||= Dir.glob("#{RAILS_ROOT}/vendor/plugins/*/app/views/my/blocks/_*.{rhtml,erb}").inject({}) do |h,file|
+          @@additional_blocks ||= Dir.glob(Rails.root.join("vendor/plugins/*/app/views/my/blocks/_*.{rhtml,erb}")).inject({}) do |h,file|
             name = File.basename(file).split('.').first.gsub(/^_/, '')
             h[name] = name.to_sym
             h
diff --git a/lib/tasks/extract_fixtures.rake b/lib/tasks/extract_fixtures.rake
index b6551a6..adfdc5b 100644
--- a/lib/tasks/extract_fixtures.rake
+++ b/lib/tasks/extract_fixtures.rake
@@ -21,7 +21,7 @@ task :extract_fixtures => :environment do
   ActiveRecord::Base.establish_connection
   (ActiveRecord::Base.connection.tables - skip_tables).each do |table_name|
     i = "000"
-    File.open("#{RAILS_ROOT}/#{table_name}.yml", 'w' ) do |file|
+    File.open(Rails.root.join("#{table_name}.yml"), 'w' ) do |file|
       data = ActiveRecord::Base.connection.select_all(sql % table_name)
       file.write data.inject({}) { |hash, record|
 
diff --git a/lib/tasks/initializers.rake b/lib/tasks/initializers.rake
index 5f54d6a..2c74c33 100644
--- a/lib/tasks/initializers.rake
+++ b/lib/tasks/initializers.rake
@@ -15,7 +15,7 @@
 desc 'Generates a configuration file for cookie store sessions.'
 
 file 'config/initializers/session_store.rb' do
-  path = File.join(RAILS_ROOT, 'config', 'initializers', 'session_store.rb')
+  path = Rails.root.join('config', 'initializers', 'session_store.rb')
   secret = ActiveSupport::SecureRandom.hex(40)
   File.open(path, 'w') do |f|
     f.write <<"EOF"
diff --git a/test/functional/application_controller_test.rb b/test/functional/application_controller_test.rb
index 258e1c4..999a5b8 100644
--- a/test/functional/application_controller_test.rb
+++ b/test/functional/application_controller_test.rb
@@ -28,7 +28,7 @@ class ApplicationControllerTest < ActionController::TestCase
 
   # check that all language files are valid
   def test_localization
-    lang_files_count = Dir["#{RAILS_ROOT}/config/locales/*.yml"].size
+    lang_files_count = Dir[Rails.root.join("config", "locales", "*.yml")].size
     assert_equal lang_files_count, valid_languages.size
     valid_languages.each do |lang|
       assert set_language_if_valid(lang)
diff --git a/test/functional/attachments_controller_test.rb b/test/functional/attachments_controller_test.rb
index 769cfb4..a478067 100644
--- a/test/functional/attachments_controller_test.rb
+++ b/test/functional/attachments_controller_test.rb
@@ -27,7 +27,7 @@ class AttachmentsControllerTest < ActionController::TestCase
     @controller = AttachmentsController.new
     @request    = ActionController::TestRequest.new
     @response   = ActionController::TestResponse.new
-    Attachment.storage_path = "#{RAILS_ROOT}/test/fixtures/files"
+    Attachment.storage_path = Rails.root.join("test", "fixtures", "files")
     User.current = nil
   end
 
diff --git a/test/functional/repositories_bazaar_controller_test.rb b/test/functional/repositories_bazaar_controller_test.rb
index 683e239..f1e9783 100644
--- a/test/functional/repositories_bazaar_controller_test.rb
+++ b/test/functional/repositories_bazaar_controller_test.rb
@@ -20,8 +20,7 @@ class RepositoriesController; def rescue_action(e) raise e end; end
 class RepositoriesBazaarControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/bazaar_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/bazaar_repository')
 
   def setup
     @controller = RepositoriesController.new
diff --git a/test/functional/repositories_cvs_controller_test.rb b/test/functional/repositories_cvs_controller_test.rb
index d77fd53..9464d0d 100644
--- a/test/functional/repositories_cvs_controller_test.rb
+++ b/test/functional/repositories_cvs_controller_test.rb
@@ -20,8 +20,7 @@ class RepositoriesController; def rescue_action(e) raise e end; end
 class RepositoriesCvsControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/cvs_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/cvs_repository').to_s
   REPOSITORY_PATH.gsub!(/\//, "\\") if Redmine::Platform.mswin?
   # CVS module
   MODULE_NAME = 'test'
diff --git a/test/functional/repositories_darcs_controller_test.rb b/test/functional/repositories_darcs_controller_test.rb
index 8c87e46..034112b 100644
--- a/test/functional/repositories_darcs_controller_test.rb
+++ b/test/functional/repositories_darcs_controller_test.rb
@@ -20,8 +20,7 @@ class RepositoriesController; def rescue_action(e) raise e end; end
 class RepositoriesDarcsControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/darcs_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/darcs_repository')
   PRJ_ID = 3
 
   def setup
diff --git a/test/functional/repositories_filesystem_controller_test.rb b/test/functional/repositories_filesystem_controller_test.rb
index fcfce0a..e2fb03d 100644
--- a/test/functional/repositories_filesystem_controller_test.rb
+++ b/test/functional/repositories_filesystem_controller_test.rb
@@ -20,8 +20,7 @@ class RepositoriesController; def rescue_action(e) raise e end; end
 class RepositoriesFilesystemControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/filesystem_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/filesystem_repository')
   PRJ_ID = 3
 
   def setup
diff --git a/test/functional/repositories_git_controller_test.rb b/test/functional/repositories_git_controller_test.rb
index ee19515..de5b3d5 100644
--- a/test/functional/repositories_git_controller_test.rb
+++ b/test/functional/repositories_git_controller_test.rb
@@ -20,8 +20,7 @@ class RepositoriesController; def rescue_action(e) raise e end; end
 class RepositoriesGitControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/git_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/git_repository').to_s
   REPOSITORY_PATH.gsub!(/\//, "\\") if Redmine::Platform.mswin?
 
   def setup
diff --git a/test/functional/repositories_mercurial_controller_test.rb b/test/functional/repositories_mercurial_controller_test.rb
index 2413808..eec91b8 100644
--- a/test/functional/repositories_mercurial_controller_test.rb
+++ b/test/functional/repositories_mercurial_controller_test.rb
@@ -21,7 +21,7 @@ class RepositoriesMercurialControllerTest < ActionController::TestCase
   fixtures :projects, :users, :roles, :members, :member_roles, :repositories, :enabled_modules
 
   # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/mercurial_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/mercurial_repository')
   CHAR_1_HEX = "\xc3\x9c"
   PRJ_ID = 3
 
diff --git a/test/test_helper.rb b/test/test_helper.rb
index ac8841a..9a881fb 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -20,7 +20,7 @@ Coveralls.wear!('rails')
 require File.expand_path(File.dirname(__FILE__) + "/../config/environment")
 require 'test_help'
 require File.expand_path(File.dirname(__FILE__) + '/helper_testcase')
-require File.join(RAILS_ROOT,'test', 'mocks', 'open_id_authentication_mock.rb')
+require Rails.root.join('test', 'mocks', 'open_id_authentication_mock.rb')
 
 require File.expand_path(File.dirname(__FILE__) + '/object_daddy_helpers')
 include ObjectDaddyHelpers
@@ -85,9 +85,9 @@ class ActiveSupport::TestCase
 
   # Use a temporary directory for attachment related tests
   def set_tmp_attachments_directory
-    Dir.mkdir "#{RAILS_ROOT}/tmp/test" unless File.directory?("#{RAILS_ROOT}/tmp/test")
-    Dir.mkdir "#{RAILS_ROOT}/tmp/test/attachments" unless File.directory?("#{RAILS_ROOT}/tmp/test/attachments")
-    Attachment.storage_path = "#{RAILS_ROOT}/tmp/test/attachments"
+    p = Rails.root.join("tmp", "test", "attachments")
+    FileUtils.mkdir_p(p)
+    Attachment.storage_path = p.to_s
   end
 
   def with_settings(options, &block)
@@ -114,7 +114,7 @@ class ActiveSupport::TestCase
 
   # Returns the path to the test +vendor+ repository
   def self.repository_path(vendor)
-    File.join(RAILS_ROOT.gsub(%r{config\/\.\.}, ''), "/tmp/test/#{vendor.downcase}_repository")
+    Rails.root.join("tmp/test/#{vendor.downcase}_repository").to_s
   end
 
   # Returns the url of the subversion test repository
diff --git a/test/unit/changeset_test.rb b/test/unit/changeset_test.rb
index 4eb11c9..36c2d2e 100644
--- a/test/unit/changeset_test.rb
+++ b/test/unit/changeset_test.rb
@@ -224,7 +224,7 @@ class ChangesetTest < ActiveSupport::TestCase
 
   def test_comments_should_be_converted_to_utf8
       proj = Project.find(3)
-      str = File.read("#{RAILS_ROOT}/test/fixtures/encoding/iso-8859-1.txt")
+      str = File.read(Rails.root.join("test/fixtures/encoding/iso-8859-1.txt"))
       r = Repository::Bazaar.create!(
             :project => proj, :url => '/tmp/test/bazaar',
             :log_encoding => 'ISO-8859-1' )
@@ -240,7 +240,7 @@ class ChangesetTest < ActiveSupport::TestCase
 
   def test_invalid_utf8_sequences_in_comments_should_be_replaced_latin1
       proj = Project.find(3)
-      str = File.read("#{RAILS_ROOT}/test/fixtures/encoding/iso-8859-1.txt")
+      str = File.read(Rails.root.join("test/fixtures/encoding/iso-8859-1.txt"))
       r = Repository::Bazaar.create!(
             :project => proj,
             :url => '/tmp/test/bazaar',
diff --git a/test/unit/helpers/repository_helper_test.rb b/test/unit/helpers/repository_helper_test.rb
index 6760f54..65661bf 100644
--- a/test/unit/helpers/repository_helper_test.rb
+++ b/test/unit/helpers/repository_helper_test.rb
@@ -85,7 +85,7 @@ class RepositoryHelperTest < HelperTestCase
 
   def test_to_utf8_for_repositories_invalid_utf8_sequences_should_be_stripped
     with_settings :repositories_encodings => '' do
-      s1 = File.read("#{RAILS_ROOT}/test/fixtures/encoding/iso-8859-1.txt")
+      s1 = File.read(Rails.root.join('test/fixtures/encoding/iso-8859-1.txt'))
       str = to_utf8_for_repositories(s1)
       if str.respond_to?(:force_encoding)
         assert_equal "Texte encod? en ISO-8859-1.", str
diff --git a/test/unit/lib/redmine/hook_test.rb b/test/unit/lib/redmine/hook_test.rb
index 1221fc4..7897f9b 100644
--- a/test/unit/lib/redmine/hook_test.rb
+++ b/test/unit/lib/redmine/hook_test.rb
@@ -162,7 +162,7 @@ class Redmine::Hook::ManagerTest < ActiveSupport::TestCase
   end
 
   def view_hook_helper
-    @view_hook_helper ||= TestHookHelperView.new(RAILS_ROOT + '/app/views')
+    @view_hook_helper ||= TestHookHelperView.new(Rails.root.join('app', 'views').to_s)
   end
 end
 
diff --git a/test/unit/lib/redmine/scm/adapters/bazaar_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/bazaar_adapter_test.rb
index 99512c0..2b2d84b 100644
--- a/test/unit/lib/redmine/scm/adapters/bazaar_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/bazaar_adapter_test.rb
@@ -18,8 +18,7 @@ begin
 
   class BazaarAdapterTest < ActiveSupport::TestCase
 
-    REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/bazaar_repository'
-    REPOSITORY_PATH.gsub!(/\/+/, '/')
+    REPOSITORY_PATH = Rails.root.join('tmp/test/bazaar_repository')
 
     if File.directory?(REPOSITORY_PATH)
       def setup
diff --git a/test/unit/lib/redmine/scm/adapters/cvs_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/cvs_adapter_test.rb
index a3d5457..5d5b26e 100644
--- a/test/unit/lib/redmine/scm/adapters/cvs_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/cvs_adapter_test.rb
@@ -18,7 +18,7 @@ begin
 
   class CvsAdapterTest < ActiveSupport::TestCase
 
-    REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/cvs_repository'
+    REPOSITORY_PATH = Rails.root.join('tmp/test/cvs_repository').to_s
     REPOSITORY_PATH.gsub!(/\//, "\\") if Redmine::Platform.mswin?
     MODULE_NAME = 'test'
 
diff --git a/test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb
index 37c84df..ed4a348 100644
--- a/test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb
@@ -18,7 +18,7 @@ begin
 
   class DarcsAdapterTest < ActiveSupport::TestCase
 
-    REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/darcs_repository'
+    REPOSITORY_PATH = Rails.root.join('tmp/test/darcs_repository')
 
     if File.directory?(REPOSITORY_PATH)
       def setup
diff --git a/test/unit/lib/redmine/scm/adapters/filesystem_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/filesystem_adapter_test.rb
index 30d2026..c6550d3 100644
--- a/test/unit/lib/redmine/scm/adapters/filesystem_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/filesystem_adapter_test.rb
@@ -17,7 +17,7 @@ require File.expand_path('../../../../../../test_helper', __FILE__)
 
 class FilesystemAdapterTest < ActiveSupport::TestCase
 
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/filesystem_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/filesystem_repository').to_s
 
   if File.directory?(REPOSITORY_PATH)
     def setup
diff --git a/test/unit/lib/redmine/scm/adapters/git_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/git_adapter_test.rb
index b59fd1a..0848bde 100644
--- a/test/unit/lib/redmine/scm/adapters/git_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/git_adapter_test.rb
@@ -20,7 +20,7 @@ begin
   require 'mocha'
 
   class GitAdapterTest < ActiveSupport::TestCase
-    REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/git_repository'
+    REPOSITORY_PATH = Rails.root.join('tmp/test/git_repository')
 
     FELIX_UTF8 = "Felix Schäfer"
     FELIX_HEX  = "Felix Sch\xC3\xA4fer"
diff --git a/test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb b/test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb
index f1e5055..f114472 100644
--- a/test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb
+++ b/test/unit/lib/redmine/scm/adapters/mercurial_adapter_test.rb
@@ -22,8 +22,7 @@ begin
     TEMPLATE_NAME = Redmine::Scm::Adapters::MercurialAdapter::TEMPLATE_NAME
     TEMPLATE_EXTENSION = Redmine::Scm::Adapters::MercurialAdapter::TEMPLATE_EXTENSION
 
-    REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/mercurial_repository'
-
+    REPOSITORY_PATH = Rails.root.join('tmp/test/mercurial_repository').to_s
     CHAR_1_HEX = "\xc3\x9c"
 
     if File.directory?(REPOSITORY_PATH)
diff --git a/test/unit/repository_bazaar_test.rb b/test/unit/repository_bazaar_test.rb
index 7d0266d..ebfc2da 100644
--- a/test/unit/repository_bazaar_test.rb
+++ b/test/unit/repository_bazaar_test.rb
@@ -16,9 +16,7 @@ require File.expand_path('../../test_helper', __FILE__)
 class RepositoryBazaarTest < ActiveSupport::TestCase
   fixtures :projects
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/bazaar_repository'
-  REPOSITORY_PATH.gsub!(/\/+/, '/')
+  REPOSITORY_PATH = Rails.root.join('tmp/test/bazaar_repository')
 
   def setup
     @project = Project.find(3)
diff --git a/test/unit/repository_cvs_test.rb b/test/unit/repository_cvs_test.rb
index fa20094..6e1c93b 100644
--- a/test/unit/repository_cvs_test.rb
+++ b/test/unit/repository_cvs_test.rb
@@ -16,8 +16,7 @@ require 'pp'
 class RepositoryCvsTest < ActiveSupport::TestCase
   fixtures :projects
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/cvs_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/cvs_repository').to_s
   REPOSITORY_PATH.gsub!(/\//, "\\") if Redmine::Platform.mswin?
   # CVS module
   MODULE_NAME = 'test'
diff --git a/test/unit/repository_darcs_test.rb b/test/unit/repository_darcs_test.rb
index 6d874a2..2e1ea08 100644
--- a/test/unit/repository_darcs_test.rb
+++ b/test/unit/repository_darcs_test.rb
@@ -16,8 +16,7 @@ require File.expand_path('../../test_helper', __FILE__)
 class RepositoryDarcsTest < ActiveSupport::TestCase
   fixtures :projects
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/darcs_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/darcs_repository')
 
   def setup
     @project = Project.find(3)
diff --git a/test/unit/repository_filesystem_test.rb b/test/unit/repository_filesystem_test.rb
index 10df1f8..21bb2a1 100644
--- a/test/unit/repository_filesystem_test.rb
+++ b/test/unit/repository_filesystem_test.rb
@@ -16,8 +16,7 @@ require File.expand_path('../../test_helper', __FILE__)
 class RepositoryFilesystemTest < ActiveSupport::TestCase
   fixtures :projects
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/filesystem_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/filesystem_repository')
 
   def setup
     @project = Project.find(3)
diff --git a/test/unit/repository_git_test.rb b/test/unit/repository_git_test.rb
index 11011a6..ee1ae18 100644
--- a/test/unit/repository_git_test.rb
+++ b/test/unit/repository_git_test.rb
@@ -16,8 +16,7 @@ require File.expand_path('../../test_helper', __FILE__)
 class RepositoryGitTest < ActiveSupport::TestCase
   fixtures :projects, :repositories, :enabled_modules, :users, :roles
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/git_repository'
+  REPOSITORY_PATH = Rails.root.join('tmp/test/git_repository').to_s
   REPOSITORY_PATH.gsub!(/\//, "\\") if Redmine::Platform.mswin?
 
   FELIX_HEX  = "Felix Sch\xC3\xA4fer"
diff --git a/test/unit/repository_mercurial_test.rb b/test/unit/repository_mercurial_test.rb
index 4132b46..533ae17 100644
--- a/test/unit/repository_mercurial_test.rb
+++ b/test/unit/repository_mercurial_test.rb
@@ -16,9 +16,7 @@ require File.expand_path('../../test_helper', __FILE__)
 class RepositoryMercurialTest < ActiveSupport::TestCase
   fixtures :projects
 
-  # No '..' in the repository path
-  REPOSITORY_PATH = RAILS_ROOT.gsub(%r{config\/\.\.}, '') + '/tmp/test/mercurial_repository'
-
+  REPOSITORY_PATH = Rails.root.join('tmp/test/mercurial_repository')
   CHAR_1_HEX = "\xc3\x9c"
 
   def setup
